HDU

来源:互联网 发布:江苏警方破获网络诈骗 编辑:程序博客网 时间:2024/05/16 00:53

这两题类似,所以放在一起了,我都是看成DAG上的dp来写的。

hdu 1069
题意:
A group of researchers are designing an experiment to test the IQ of a monkey. They will hang a banana at the roof of a building, and at the mean time, provide the monkey with some blocks. If the monkey is clever enough, it shall be able to reach the banana by placing one block on the top another to build a tower and climb up to get its favorite food.

The researchers have n types of blocks, and an unlimited supply of blocks of each type. Each type-i block was a rectangular solid with linear dimensions (xi, yi, zi). A block could be reoriented so that any two of its three dimensions determined the dimensions of the base and the other dimension was the height.

They want to make sure that the tallest tower possible by stacking blocks can reach the roof. The problem is that, in building a tower, one block could only be placed on top of another block as long as the two base dimensions of the upper block were both strictly smaller than the corresponding base dimensions of the lower block because there has to be some space for the monkey to step on. This meant, for example, that blocks oriented to have equal-sized bases couldn’t be stacked.

Your job is to write a program that determines the height of the tallest tower the monkey can build with a given set of blocks.
Input
The input file will contain one or more test cases. The first line of each test case contains an integer n,
representing the number of different blocks in the following data set. The maximum value for n is 30.
Each of the next n lines contains three integers representing the values xi, yi and zi.
Input is terminated by a value of zero (0) for n.
Output
For each test case, print one line containing the case number (they are numbered sequentially starting from 1) and the height of the tallest possible tower in the format “Case case: maximum height = height”.
Sample Input
1
10 20 30
2
6 8 10
5 5 5
7
1 1 1
2 2 2
3 3 3
4 4 4
5 5 5
6 6 6
7 7 7
5
31 41 59
26 53 58
97 93 23
84 62 64
33 83 27
0
Sample Output
Case 1: maximum height = 40
Case 2: maximum height = 21
Case 3: maximum height = 28
Case 4: maximum height = 342

思路:
明显的DAG,有向无环图。 数据有30,由于x,y,z不确定,所以最多也就90个块,由于长宽是不能等的(等了就可以无限堆了),所以也就是这些块放的顺序的问题了,假设所有的块都和严格比它长宽要长的块有关系,这样就可以搞出一张DAG。
状态转移: dp[i] = max(dp[k] + data[i]); k是与i有关系的块。
这一题的排序是必须的。因为大的块的dp的值必须先出来,才能对后面的进行处理。

#include <cstdio>#include <cstring>#include <iostream>#include <algorithm>using namespace std;#define maxn 150#define inf 0x3f3f3f3fint g[maxn][maxn];struct node{    int x,y,z;    node(int a,int b,int c)    {        x = a; y = b; z = c;    }    node(){}}data[maxn];bool cmp(node a,node b){    if(a.x == b.x)    {        return a.y > b.y;    }    else return a.x > b.x;}int d[maxn];int k = 0;int main(){    int kase = 1;    int n;    while(~scanf("%d",&n) && n)    {        memset(d,0,sizeof(d));        memset(g,0,sizeof(g));        k = 0;        for(int i = 0; i < n; i++)        {            int a,b,c;            scanf("%d%d%d",&a,&b,&c);            data[k++] = node(min(a,b),max(a,b),c);            data[k++] = node(min(a,c),max(a,c),b);            data[k++] = node(min(b,c),max(b,c),a);        }        //cout<<endl;        sort(data,data+k,cmp);        for(int i = 0; i < k ; i++)        {            for(int j = 0; j < k ; j++)            {                if(data[j].x < data[i].x && data[j].y < data[i].y)                    g[j][i] = 1;            }        }        for(int i = 0;i < k; i++)        {            int ans = data[i].z;            for(int j = 0; j < k ; j++)            {                if(g[i][j])                ans = max(ans,d[j] + data[i].z);            }            d[i] = ans;        }       // /for(int i = 0; i < k; i++)            //cout<<d[i]<<endl;        int maxans = 0;        for(int i = 0; i < k ; i++)            maxans = max(maxans,d[i]);        printf("Case %d: maximum height = %d\n",kase++, maxans);    }    return 0;}

hdu1087
题意:
求最长上升子序列。
思路:
感觉这题和上面一题其实类似,都可以推出:
dp[i] = max(dp[k] + data[i]); k是小于i的 而且 data[i] > data[j]
其实这题的g[i][j]可以不用,只是我觉得和上面题目思路确实相似。

#include <cstdio>#include <cstring>#include <iostream>#include <algorithm>using namespace std;#define LL long long#define maxn 1005LL dp[maxn];int data[maxn];int g[maxn][maxn];int main(){    int n;    while(~scanf("%d",&n) && n)    {        memset(dp,0,sizeof(dp));        memset(g,0,sizeof(g));        for(int i = 0; i < n ; i++)            scanf("%d",&data[i]);        for(int i = 0; i < n ; i++)        {            for(int j = i+1; j < n; j++)                if(data[i] < data[j])                    g[i][j] = 1;        }        dp[0] = data[0];        for(int i = 1; i < n ; i++)        {            LL ans = data[i];            for(int j = i-1; j >= 0 ; j--)            {                if(g[j][i])                    ans = max(ans,data[i] + dp[j]);            }            dp[i] = ans;        }        LL ans = 0;        for(int i = 0; i < n ; i++)            if(dp[i] > ans)            ans = dp[i];        printf("%I64d\n",ans);    }    return 0;}
0 0
原创粉丝点击